-- why does this need player anyways?
-- that seems like a liability with player required by the module to provide
require 'base.scripts.clientinput'
require 'base.scripts.clientside'
require 'base.scripts.client'		--createClientStartClass
require 'base.scripts.menuent'		--makeEntityMenuCapable

-- clientside object


entclass('ClientView', Renderable)

ClientView.clientAck = false

function ClientView:ctor(so, doUpdateTags)
	doUpdateTags = doUpdateTags or true
	ClientView.super.ctor(self,so)

	self.screenFlash = vec4:new(0,0,0,0)
	
	self.tag = -1
	if doUpdateTags then
		self:updateTagsFromPos(self:getPos())
	end
	
	self.control = true
	self.input = ClientInput:new()
	
	local targetSP = -1
	if so and so.target then
		local target = SpawnObj:new(so.target)	-- should there be a better way to do this.
		local ep = target._ent
		local e = _ents[ep]
		if e then
			self:followTarget(e)
		else
			if target:_createEnt() then	-- TODO - implement me
				ep = target._ent
				e = _ents[ep]
				if e then
					self:followTarget(e)
				end
			else
				print('ClientView failed to spawn target!')
			end
		end
	end
end
	
-- currently I have no implementation for dtors ...
function ClientView:dtor()
	self:updateTags(-1)
end
	
function ClientView:updateTagsFromPos(pos)
	local userTag = mapGetTag(math.floor(pos[1]), math.floor(pos[2]))
	self:updateTags(userTag)
end
	
function ClientView:updateTags(userTag)
	spawnObjSystemUpdateTags(userTag, self.tag)
	self.tag = userTag
end
	
function ClientView:think()
	ClientView.super.think(self)
	if not self:isActive() then return end	-- needed for any whose parent think() might kill themselves (Collidable)

	if self.follow and self.target then	--and self.target.active .. ?
		self:setPos(self.target:getPos())
	end
	
	--copy input into client from a follow target pointer ... somehow ...
	if self.control and self.target and self.target.input then
		self.target.input:copyFrom(self.input)
	end
end
	
-- get client info ... too .. how to redo this

function ClientView:followTarget(other)
	self.follow = other ~= nil
	self.target = other
end


-- cl/sv communication

function ClientView:serverRecvMessage(cmd, ...)
	local f = self[cmd]
	if not f then
		print('ClientView:serverRecvMessage got an unknown command ',cmd)
	else
		f(self, ...)
	end
end

function ClientView.clientRecvMessage(cmd, ...)
	local cl = ClientSide:getClient()
	local f = cl[cmd]
	if not f then
		print('ClientView.clientRecvMessage got an unknown command ',cmd)
	else
		f(cl, ...)
	end
end

function ClientView.clientUpdate(classObj)
	ClientView.super.clientUpdate(classObj)

	-- todo - move this to C code for all connections
	if not net.clientAck then net.clientAck = true end

	-- here's our update-the-clientside command,
	-- needs to be executed by whatever class is gonna handle clientside stuff
	ClientSide:getClient():update()
end

ClientView:createNetTable{
	clientAck = 'bool';
}

-- bindings

createClientStartClass(ClientView, 'marker', box2:new(.4))


makeEntityMenuCapable(ClientView)
