require 'bomblo.scripts.base'

animLoad('chest', {
	sprites = {
		{file = 'chest.png'; };
		{file = 'chest_open.png'; };
	};
	seqs = {
		idle = {{joint = 1; time = 0; sprite = 1; }};
		open = {{joint = 1; time = 0; sprite = 2; }};
	};
})

entclass('Chest', Base)
Chest.animGroup = 'chest'
Chest.bbox = box2:new(.4)
Spawnable(Chest)

-- treasure chests dont block movable things
Chest.isBlocking = false
Chest.isOpen = false	-- set this to true when someone can open it (last heart grabbed)

function Chest:open()
	-- now I could do this per-instance, like 'self.isOpen = true'
	-- but the truth of it all is once one chest opens, they all open
	-- to top that off, since we know recompiles go on before each level
	-- we can safely mess with the class code knowing it will safely be thrown away later
	--self.isOpen = true
	Chest.isOpen = true

	self:setAnimSeq('open')
end

function Chest:endPush(who, where)
	if not who:isa(Player) then return end
	if not self.isOpen then return end

	-- only if we step exactly on it
	if (where - self:getPos()):lenLInf() >= 0.5 then return end

	-- now find the door and open it
	for i,e in pairs(_ents) do
		-- if e is an egg or e is a monster then destroy it
		-- keep the framers
		-- keep the chest
		-- keep the player
		-- keep the door
		if e:isa(Base) then
			e:onChestOpen()
		end
	end
	
	-- dont need to run this again
	self.endPush = function() end
end

