require 'bomblo.scripts.base'

animLoad('door', {
	sprites = {
		{file='door.png'};
		{file='door_open.png'};
	};
	seqs = {
		idle = {{joint = 1; time = 0; sprite = 1;}};
		open = {{joint = 1; time = 0; sprite = 2;}};
	};
})

entclass('Door', Base)
Door.animGroup = 'door'
Door.bbox = box2:new(.4)
Spawnable(Door, 'the end of the level')

Door.isBlockingPushers = false

function Door:ctor(so)
	Door.super.ctor(self,so)
	
	-- set this to true when we get the session level
	-- that way we will only increment the level counter once per session
	if not Door.level then
		-- get the level var
		local level = persist.level
		-- cast to a number, starting at zero
		if level then level = tonumber(level) else level = 0 end
		-- store it in the class
		Door.levelNumber = level
		-- set our default next level (if no override is provided)
		Door.level = 'l'..(level+1)..'.world'
	end
	
	if so then
		if so.level then self.level = so.level end
	end
end

-- use the 'isBlocking' flag as our open flag here
-- clear 'isBlocking' when the user touches the chest and ends the level
function Door:onChestOpen()
	self.isBlocking = false
	self:setAnimSeq('open')
end

function Door:endPush(who, where)
	if not who:isa(Player) then return end
	-- only if we step exactly on it
	if (where - self:getPos()):lenLInf() >= 0.5 then return end
	
	-- do a level end here
	print('CONGRATULATIONS!')
	
	if self.level then
		-- here, just before changing level,
		-- increment our counter and save it in the session vars
		persist.level = Door.levelNumber+1

		print('switching over to level ' .. self.level)
		loadWorld(self.level)
	end
end
