require 'bomblo.scripts.movable'

entclass('Pushable', Movable)

-- whether this object can be pushed into the water
Pushable.canSink = false

-- whether this object has been pushed in the water
Pushable.isSunk = false

function Pushable:startPush(who, pushDest, side)
	local isBlocking = Pushable.super.startPush(who,pushDest,side)
	
		-- only players push for now
	do --if who:isa(Player) then
		-- if you shoot an egg you're mid-pushing then
		-- bad things happen
		if not self.isBlocking then return false end
	
		local align = false
		--make sure we're on the same half tile
		if side == SIDE.LEFT or side == SIDE.RIGHT then
			align = math.abs(self:getPosY() - who:getPosY()) < 0.4
		elseif side == SIDE.UP or side == SIDE.DOWN then
			align = math.abs(self:getPosX() - who:getPosX()) < 0.4
		end

		-- dont be pushed if we already are moving
		if align and not self.moveFrac then
			-- do a step in the direction that we're told
			local moveResponse = self:doMove(side)
			-- if its not valid then return a true here
			if moveResponse == self.MOVE_RESPONSE.WAS_BLOCKED then
				return true
			end
			
			-- if it is valid then remember where we're going and return a false
			if moveResponse == self.MOVE_RESPONSE.DID_MOVE then
				return true -- return ? false? true? isBlocking?
			end
		end
	end
	
	return isBlocking
end

-- doMove should fail if the source is Pushable (i.e. me)
-- and its dest is ANYTHING by default (overridable by bridges, arrows, etc)
-- ok we could either store who things cannot be pushed on in their class 
-- or we could store the list in each pushable's class
-- might as well just keep it all right here?
-- nah, extensibility's sake, keep it in every unique class
-- so upon either our hitObject we test its 'pushedOver' flag and return?
-- or we do that in their startPush class?
function Pushable:hitObject(who, where, dir)
	if who.isBlockingPushers then return self.HIT_RESPONSE.STOP end
	return Pushable.super.hitObject(self,who,where,dir)
end
