require 'data.scripts.walkenemy'

animLoad('intangir', {
	sprites = {{file='intangir.tga',bbox={-2,-3,2,3}}};
	seqs = {
		idle = {{joint = 1; time = 0; sprite = 1}};
		die = {{joint = 1; time = 0; sprite = 1}};
	};
})

entclass('Intangir', WalkEnemy, {
	animGroup = 'intangir';
	bbox = box2:new(-1.95, -2.95, 1.95, 2.95);
	maxHealth = 15,
	attackFinished = -100,	-- negative infinity, if you can find it

	think = function(self)
		Intangir.super.think(self)
		if not self:isActive() then return end	-- needed for any whose parent think() might kill themselves (Collidable)
		if self:getIgnoreEnts() then return end		-- we're dead
		
		if self.attackFinished < getTime() + 0.3 then
			local dir = vec2:new()
			if self:getVelX() < 0 then dir[1] = -1 else dir[1] = 1 end
			weaponFlameThrower.attackFunc(self, dir)
		end
		if self.attackFinished < getTime() then
			self.attackFinished = getTime() + 0.6
		end
	end,
})

Spawnable(Intangir)
