require 'data.scripts.jumpenemy'
require 'data.scripts.weapons'

animLoad('mario', {
	sprites = {
		{file='mario/mario_stand.tga', bbox={-.5,-1.5,.5,.5}};
		{file='mario/mario_jump.tga', bbox={-.5,-1.5,.5,.5}};
		{file='mario/mario_walk1.tga', bbox={-.5,-1.5,.5,.5}};
		{file='mario/mario_walk2.tga', bbox={-.5,-1.5,.5,.5}};
	};
	seqs = {
		idle = {{joint=1; time=0; sprite=1}};
		pain = {{joint=1; time=0; sprite=2}};
		run = {
			{joint=1; time=0; sprite=4};
			{joint=1; time=.1; sprite=1};
			{joint=1; time=.2; sprite=4};
		};
		jump = {{joint=1; time=0; sprite=2}};
		attack = {{joint=1; time=0; sprite=2}};
		die = {{joint=1; time=0; sprite=2}};
	};
})


entclass('Mario', JumpEnemy, {
	animGroup = 'mario';
	bbox = box2:new(-.45,-1.45,.45,.45);
	maxHealth = 25,

	touch = function(self, other)
		Mario.super.touch(self,other)
		if other and other:isa(TakesDamage) and other.health > 0 then
			if self:getContactEnt() == other then
				if self:getContactNormalY() < 0.5 then
					if not other:isa(Mario) then
						other:takeDamage(self, 1)
					end
				end
				
				if self:getContactNormalX() > 0.5 then other:setVelX(other:getVelX() - 5) end
				if self:getContactNormalX() < -0.5 then other:setVelX(other:getVelX() + 5) end
			end
		end
	end
})
Spawnable(Mario)
