-- depends on battle.lua for battleCmdPickTargets

battlecmds = {

	{name='Fight', run=function(cmd, battle, team, char)
		local targetting = char:getFightTargetting()
		local others = battleCmdPickTargets(cmd, battle, team, char, targetting)
		if #others > 0 then
			char:lookAtGroup(others)
			for _,other in ipairs(others) do
				battleDoFight(other, char)
			end
			return true
		end
	end};

	{name='Item', run=function(cmd, battle, team, char)
		local itemIndex = battleCmdPickItem(cmd, battle, team, char)
		if itemIndex then
			local targetting = battleItemTargetting(itemIndex)
			local others = battleCmdPickTargets(cmd, battle, team, char, targetting)
			if #others > 0 then
				char:lookAtGroup(others)
				for _,other in ipairs(others) do
					battleDoItem(other, char, itemIndex)
				end
				return true
			end
		end
	end};
	
	{name='Magic', run=function(cmd, battle, team, char)
		local spellIndex = battleCmdPickSpell(cmd, battle, team, char)
		if spellIndex then
			local targetting = battleSpellTargetting(spellIndex)
			local others = battleCmdPickTargets(cmd, battle, team, char, targetting)
			if #others > 0 then
				char:lookAtGroup(others)
				for _,other in ipairs(others) do
					battleDoSpell(other, char, spellIndex)
				end
				return true
			end
		end
	end};
	
	-- Morph
	-- Revert
	-- Steal
	-- Capture
	-- Sword Tech
	-- Throw
	-- Tools
	-- Blitz
	-- Runiz
	-- Lore
	-- Sketch
	-- Control
	-- Slot
	-- Rage
	-- Leap
	-- Mimic
	-- Dance
	-- Jump
	-- X Magic
	-- GP Rain
	-- Summon
	-- Health
	-- Shock
	-- Possess
	-- MagiTek
	
		-- special case for battle cmds
	-- Row
	-- Defend

	-- default special skill for the time being
	{name='Special', run=function(cmd, battle, team, char)
	end};

}

-- associate by name too
battleCmdIndexFromName = {}
for i,c in ipairs(battlecmds) do battleCmdIndexFromName[c.name] = i end
